//	Maze4DGPUDefinitions.swift
//
//	© 2023 by Jeff Weeks
//	See TermsOfUse.txt

#ifndef Maze4DGPUDefinitions_h
#define Maze4DGPUDefinitions_h

#include <simd/simd.h>
#include "../../../Shared/GeometryGamesFauxSimd.h"	//	Metal files need explicit path

enum
{
	VertexAttributePosition	= 0,
	VertexAttributeNormal	= 1,
	VertexAttributeWeight	= 2
};

enum
{
	BufferIndexVertexAttributes	= 0,
	BufferIndexUniforms			= 1,
	BufferIndexInstanceData		= 2
};

typedef struct
{
	simd_float4x4	itsModelMatrix;
	faux_simd_half3	itsRGB;		//	(red, green, blue) for a single color
} Maze4DInstanceDataRGB;

typedef struct
{
	simd_float4x4	itsModelMatrix;
	faux_simd_half2	itsHues;	//	(hue A, hue B) for two colors to be interpolated
} Maze4DInstanceDataHues;

typedef struct
{
	simd_float4x4			itsViewProjectionMatrix;

	faux_simd_half4			itsFogEvaluator;		//	assumes model matrix already applied
	
	faux_simd_half3			itsDiffuseEvaluator,	//	assumes model matrix already applied
							itsSpecularEvaluator;	//	assumes model matrix already applied

	Maze4DInstanceDataRGB	itsSliderInstanceData,
							itsGoalInstanceData,
							itsBoxInstanceData;

} Maze4DUniformData;

#endif /* Maze4DGPUDefinitions_h */
